# swagger-client
Ingram Micro product catalog API for requesting price and availability of SKUs in real time.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 5.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen
For more information, please visit [https://developer.ingrammicro.com/contact](https://developer.ingrammicro.com/contact)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.CatalogApi(swagger_client.ApiClient(configuration))
customer_number = '20-222222' # str | Your unique Ingram Micro customer number (default to 20-222222)
iso_country_code = 'US' # str | 2 chars country code (default to US)
part_number = '1AQ821' # str | Part Number can be ingram part number or vendor part number or customer part number or UPC (default to 1AQ821)

try:
    # Search product catalog
    api_response = api_instance.get_v5_catalog_productsearch(customer_number, iso_country_code, part_number)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CatalogApi->get_v5_catalog_productsearch: %s\n" % e)

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.CatalogApi(swagger_client.ApiClient(configuration))
body = swagger_client.PriceAndAvailabilityRequest() # PriceAndAvailabilityRequest |  (optional)

try:
    # Find availability of upto 50 SKUs
    api_response = api_instance.multi_sku_price_and_stock(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CatalogApi->multi_sku_price_and_stock: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CatalogApi* | [**get_v5_catalog_productsearch**](docs/CatalogApi.md#get_v5_catalog_productsearch) | **GET** /catalog | Search product catalog
*CatalogApi* | [**multi_sku_price_and_stock**](docs/CatalogApi.md#multi_sku_price_and_stock) | **POST** /catalog/priceandavailability | Find availability of upto 50 SKUs

## Documentation For Models

 - [PriceAndAvailabilityRequest](docs/PriceAndAvailabilityRequest.md)
 - [PriceAndAvailabilityRequestServicerequest](docs/PriceAndAvailabilityRequestServicerequest.md)
 - [PriceAndAvailabilityRequestServicerequestPriceandstockrequest](docs/PriceAndAvailabilityRequestServicerequestPriceandstockrequest.md)
 - [PriceAndAvailabilityRequestServicerequestPriceandstockrequestItem](docs/PriceAndAvailabilityRequestServicerequestPriceandstockrequestItem.md)
 - [PriceAndAvailabilityRequestServicerequestRequestpreamble](docs/PriceAndAvailabilityRequestServicerequestRequestpreamble.md)
 - [PriceAndAvailabilityResponse](docs/PriceAndAvailabilityResponse.md)
 - [PriceAndAvailabilityResponseServiceresponse](docs/PriceAndAvailabilityResponseServiceresponse.md)
 - [PriceAndAvailabilityResponseServiceresponsePriceandstockresponse](docs/PriceAndAvailabilityResponseServiceresponsePriceandstockresponse.md)
 - [PriceAndAvailabilityResponseServiceresponsePriceandstockresponseDetails](docs/PriceAndAvailabilityResponseServiceresponsePriceandstockresponseDetails.md)
 - [PriceAndAvailabilityResponseServiceresponseResponsepreamble](docs/PriceAndAvailabilityResponseServiceresponseResponsepreamble.md)
 - [ProductSearchResponse](docs/ProductSearchResponse.md)
 - [ProductSearchResponseServiceresponse](docs/ProductSearchResponseServiceresponse.md)
 - [ProductSearchResponseServiceresponsePartnumbers](docs/ProductSearchResponseServiceresponsePartnumbers.md)
 - [ProductSearchResponseServiceresponseProductsearchresponse](docs/ProductSearchResponseServiceresponseProductsearchresponse.md)
 - [ProductSearchResponseServiceresponseResponsepreamble](docs/ProductSearchResponseServiceresponseResponsepreamble.md)
 - [WarehouseListType](docs/WarehouseListType.md)

## Documentation For Authorization


## application

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - ****: 


## Author


